var spinner = document.getElementById("loader");

window.addEventListener("load", function () {
  spinner.classList.toggle("hidden");
});

const onToggleMenu = (elmt) => {
  const menu = document.getElementById("menu");
  if (menu.classList.contains("hidden")) {
    menu.classList.remove("hidden");
    elmt.name = "close";
  } else {
    menu.classList.add("hidden");
    elmt.name = "menu";
  }
};


let indicator = document.querySelector(".scroll-indicator .progress");
let scrollHeight =
  document.documentElement.scrollHeight - document.documentElement.clientHeight;

window.addEventListener("scroll", scroll);

function scroll() {
  let scrollTop = document.documentElement.scrollTop;
  let scrolled = (scrollTop / scrollHeight) * 100;
  indicator.style.width = `${scrolled}%`;
}

// ...onToggleMenu...

const scrollToSection = (id) => {
  const element = document.getElementById(id);
  if (element) {
    const elementPosition =
      element.getBoundingClientRect().top + window.pageYOffset;
    const startPosition = window.pageYOffset;
    const distance = elementPosition - startPosition;
    const duration = 800;
    let startTime = null;

    const ease = (t, b, c, d) => {
      t /= d / 2;
      if (t < 1) return (c / 2) * t * t + b;
      t--;
      return (-c / 2) * (t * (t - 2) - 1) + b;
    };

    const animation = (currentTime) => {
      if (startTime === null) startTime = currentTime;
      const timeElapsed = currentTime - startTime;
      const run = ease(timeElapsed, startPosition, distance, duration);
      window.scrollTo(0, run);
      if (timeElapsed < duration) requestAnimationFrame(animation);
    };

    requestAnimationFrame(animation);
  }
};

// ...onToggleMenu...


const verify = () => {
  var name = document.getElementById("name").value;
  var email = document.getElementById("email").value;
  var message = document.getElementById("message").value;

  if (name == "") {
    alert("Please Enter Your Name.");
    return null;
  } else if (email == "") {
    alert("Please Enter Your E-mail.");
    return null;
  } else if (message == "") {
    alert("Please Enter Your Message.");
    return null;
  } else {
    var obj = JSON.stringify({
      name: name,
      email: email,
      message: message,
    });
    return obj;
  }
};

const sendMessage = () => {
  var loader = document.getElementById("loader");
  var obj = verify();
  if (obj != null) {
    loader.classList.toggle("hidden");
    var f = new FormData();
    f.append("obj", obj);

    var r = new XMLHttpRequest();

    r.onreadystatechange = () => {
      if (r.readyState == 4 && r.status == 200) {
        var newObj = JSON.parse(r.responseText);
        loader.classList.toggle("hidden");
        alert(newObj.msg);
        window.location.reload();
      }
    };

    r.open("POST", "./Process/sendEmailProcess.php", true);
    r.send(f);
  }
};

const payNow = (id) => {
  var object = JSON.stringify({
    name: document.getElementById("name").value,
    whatsapp: document.getElementById("whatsapp").value,
    email: document.getElementById("email").value,
    password: document.getElementById("password").value,
    sid: document.getElementById("id").value,
  });
  document.getElementById("PayPalDiv").classList.toggle("hidden");
  if (id != 0) {
    var f = new FormData();
    f.append("obj", object);
    var r = new XMLHttpRequest();

    r.onreadystatechange = () => {
      if (r.readyState === 4 && r.status === 200) {
        var detailsObject = JSON.parse(r.responseText);
        if (paypal && paypal.Buttons) {
          let amount = detailsObject.amount;
          let roundedAmount = amount.toFixed(2);
          paypal
            .Buttons({
              createOrder: (data, actions) => {
                return actions.order.create({
                  purchase_units: [
                    {
                      amount: {
                        currency_code: "USD",
                        value: roundedAmount,
                        breakdown: {
                          item_total: {
                            currency_code: "USD",
                            value: roundedAmount,
                          },
                        },
                      },
                      items: [
                        {
                          name: detailsObject.name,
                          description: detailsObject.description,
                          unit_amount: {
                            currency_code: "USD",
                            value: roundedAmount,
                          },
                          quantity: "1",
                        },
                      ],
                    },
                  ],
                });
              },
              onApprove: (data, actions) => {
                return actions.order.capture().then(function (orderData) {
                  console.log("Capture result", orderData);
                  saveinvoice(detailsObject);
                });
              },
            })
            .render("#paypal-button-container");
        } else {
          console.error("PayPal Buttons SDK is not loaded correctly.");
        }
      }
    };

    r.open("POST", "./Process/insertUser.php", true);
    r.send(f);
  }
};

const saveinvoice = (obj) => {
  var f = new FormData();
  f.append("obj", JSON.stringify(obj));
  var r = new XMLHttpRequest();

  r.onreadystatechange = () => {
    if (r.readyState === 4 && r.status === 200) {
      var newObject = JSON.parse(r.responseText);
      if (newObject.msg == "1") {
        window.location = "./invoice.php?id=" + newObject.iid;
      } else {
        alert(t);
      }
    }
  };

  r.open("POST", "./Process/saveInvoice.php", true);
  r.send(f);
};

const registerCustomer = async () => {
  var data = JSON.stringify({
    fname: document.getElementById("fname").value,
    lname: document.getElementById("lname").value,
    mobile: document.getElementById("mobile").value,
    email: document.getElementById("email").value,
    password: document.getElementById("password").value,
  });

  var f = new FormData();
  f.append("obj", data);

  var r = new XMLHttpRequest();
  r.onreadystatechange = () => {
    if (r.readyState === 4 && r.status === 200) {
      alert(r.responseText);
    }
  };

  r.open("POST", "../Process/Register.php", true);
  r.send(f);
};

var customerId;
const editCustomer = (id) => {
  customerId = id;
  document.getElementById("fn").value = document.getElementById(
    id + "fname"
  ).innerHTML;
  document.getElementById("ln").value = document.getElementById(
    id + "lname"
  ).innerHTML;
  document.getElementById("m").value = document.getElementById(
    id + "mobile"
  ).innerHTML;
  document.getElementById("e").value = document.getElementById(
    id + "email"
  ).innerHTML;
  document.getElementById("p").value = document.getElementById(
    id + "password"
  ).innerHTML;
};
const editCus = () => {
  const data = {
    fname: document.getElementById("fn").value,
    lname: document.getElementById("ln").value,
    mobile: document.getElementById("m").value,
    email: document.getElementById("e").value,
    password: document.getElementById("p").value,
    id: customerId,
  };

  var f = new FormData();
  f.append("obj", JSON.stringify(data));

  var r = new XMLHttpRequest();
  r.onreadystatechange = () => {
    if (r.readyState === 4 && r.status === 200) {
      alert(r.responseText);
      window.location.reload();
    }
  };

  r.open("POST", "./updateCustomer.php", true);
  r.send(f);
};

const deleteCustomer = (id) => {
  var r = new XMLHttpRequest();
  r.onreadystatechange = () => {
    if (r.readyState === 4 && r.status === 200) {
      alert(r.responseText);
      window.location.reload();
    }
  };

  r.open("GET", "./deleteCustomer.php?id=" + id, true);
  r.send();
};
